#include "../utils.h"
#include "../factory_objects.h"
#include "../resources.h"
#include "../camera.h"

typedef struct actor_spikes_s
{
    object_t *self_object;
    sprite_t *sprite;
    vector_t  position;
    bool      hit;
} actor_spikes_t;

static void _Actor_Spikes_CreateAnimations(actor_spikes_t *actor)
{
    Sprite_AnimationAdd(actor->sprite, "idle", 4);
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(0,  0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(16, 0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(32, 0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(48, 0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(64, 0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(80, 0, 16, 16));
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(96, 0, 16, 16));
}

static void _Actor_Spikes_GetInfo(actor_spikes_t *actor, object_info_t *info)
{
    if (actor == NULL)
        return;

    if (info == NULL)
        return;

    info->box_rect       = Utils_GetRect(0, 0, 0, 0);
    info->collision_rect = Utils_GetRect(0, 0, 0, 0);
    info->position       = actor->position;

    if (actor->sprite != NULL)
    {
        info->box_rect.x = actor->position.x - actor->sprite->origin.x;
        info->box_rect.y = actor->position.y - actor->sprite->origin.y;
        info->box_rect.w = actor->sprite->width;
        info->box_rect.h = actor->sprite->height;

        info->collision_rect.x = actor->position.x - (actor->sprite->width / 2);
        info->collision_rect.y = actor->position.y - (actor->sprite->height / 2);
        info->collision_rect.w = actor->sprite->width;
        info->collision_rect.h = actor->sprite->height;
    }

    info->collision_cell_ul = Utils_GetPoint(0, 0);
    info->collision_cell_br = Utils_GetPoint(0, 0);
}

static void _Actor_Spikes_Collision(actor_spikes_t *actor, void *actor_collision, actor_type_t actor_type)
{
    if (actor == NULL)
        return;

    if (actor_collision == NULL)
        return;

    if (actor_type == AT_ROBO)
    {
        if (!actor->hit)
        {
            actor->hit = true;

            Actor_Robo_Hit(actor_collision);

            Sprite_AnimationPlay(actor->sprite, "idle", false);
        }
    }
}

static void _Actor_Spikes_Update(actor_spikes_t *actor, float dt)
{
    if (actor == NULL)
        return;

    if (actor->hit)
    {
        if (Sprite_IsEndCurrentAnimation(actor->sprite))
            actor->hit = false;
    }

    Sprite_Update(actor->sprite);
}

static void _Actor_Spikes_Draw(SDL_Renderer *renderer, actor_spikes_t *actor)
{
    if (actor == NULL)
        return;

    if (actor->sprite != NULL)
    {
        Sprite_Draw(renderer, actor->sprite, actor->position);
    }
}

static void _Actor_Spikes_Free(actor_spikes_t *actor)
{
    if (actor == NULL)
        return;

    Sprite_Free(actor->sprite);

    free(actor);

    actor = NULL;
}

void Actor_Spikes_Create(object_t *object, float x, float y)
{
    if (object != NULL)
    {
        actor_spikes_t *actor = (actor_spikes_t*)malloc(sizeof(actor_spikes_t));

        actor->self_object = object;

        FactoryObjects_SetActor(object, (void*)actor, AT_SPIKES, OLAY_TILES);

        FactoryObjects_SetFunc(object, _Actor_Spikes_GetInfo,   OFUNC_GETINFO);
        FactoryObjects_SetFunc(object, _Actor_Spikes_Collision, OFUNC_COLLISION);
        FactoryObjects_SetFunc(object, _Actor_Spikes_Update,    OFUNC_UPDATE);
        FactoryObjects_SetFunc(object, _Actor_Spikes_Draw,      OFUNC_DRAW);
        FactoryObjects_SetFunc(object, _Actor_Spikes_Free,      OFUNC_FREE);

        actor->sprite   = Sprite_Create(Utils_GetPoint(24, 24), 48, 48, spikesTex);
        actor->position = Utils_GetVector(x, y);
        actor->hit      = false;

        _Actor_Spikes_CreateAnimations(actor);
    }
}
